package com.zsc.edu.dify.modules.dify.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IEnum;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.zsc.edu.dify.framework.json.JsonbTypeHandler;
import io.github.guoshiqiufeng.dify.server.dto.response.AppsResponseVO;
import lombok.*;

import java.util.List;
import java.util.Map;

/**
 * @author zhuang
 *
 *
 */
@EqualsAndHashCode(callSuper = true)
@Getter
@Setter
@TableName("apps_entity")
public class AppEntity extends AppsResponseVO {

    @TableField(typeHandler = JsonbTypeHandler.class)
    private Map<String, Object> modelConfig;

    @TableField(typeHandler = JsonbTypeHandler.class)
    private Map<String, Object> workflow;

    @TableField(typeHandler = JsonbTypeHandler.class)
    private List<String> tags;

    @TableField(typeHandler = JsonbTypeHandler.class)
    private Map<String, Object> site;

    @TableField(typeHandler = JsonbTypeHandler.class)
    private List<String> deletedTools;

    private boolean enabled;

    private String apiKey;
    /**
     * 子菜单
     */
    @TableField(exist = false)
    private List<AppEntity> children = null;

    @TableField(value = "create_id", fill = FieldFill.INSERT)
    private Long createId;

    @TableField(value = "dept_id", fill = FieldFill.INSERT)
    private Long deptId;

    private AppType appType;

    public enum AppType implements IEnum<Integer>{
        WORD(1),
        PPT(2),
        SCRAPER(3);

        private final Integer value;

        AppType(int value) {
            this.value=value;
        }
        @Override
        public Integer getValue() {
            return this.value;
        }
    }
}
